package io.trygvis.soilmoisture;

import java.util.Date;

class SmSensor {
    private final SmDevice device;

    public final long id;

    public final int index;

    private String name;

    private Date timestamp;

    private Integer lastValue;

    private Integer warningValue;

    SmSensor(SmDevice device, long id, int index) {
        this.device = device;
        this.id = id;
        this.index = index;
        this.name = "Sensor #" + index;
    }

    public SmDevice getDevice() {
        return device;
    }

    public long getId() {
        return id;
    }

    public int getIndex() {
        return index;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getLastValue() {
        return lastValue;
    }

    public Integer getWarningValue() {
        return warningValue;
    }

    public void setWarningValue(Integer warningValue) {
        this.warningValue = warningValue;
    }

    public Date getTimestamp() {
        return timestamp;
    }

    // -----------------------------------------------------------------------
    //
    // -----------------------------------------------------------------------

    public String toString() {
        return "SmSensor[id=" + id + ", " +
                "device=" + device.getBtDevice().getAddress() + ", " +
                "name=" + (name != null ? name : "unknown") + ", " +
                "index=" + getIndex() + "]";
    }

    public void readCurrentValue() {
        device.smService.readCurrentValue(this);
    }

    void updateLastValue(Date timestamp, int lastValue) {
        this.timestamp = timestamp;
        this.lastValue = lastValue;
    }

    public void readWarningValue() {
        device.smService.readWarningValue(this);
    }
}
